--- HISTORY	2006/09/24 18:19:09
+++ HISTORY	2006/11/05 23:47:03
@@ -1,3 +1,11 @@
+OpenBSM 1.0 alpha 13
+
+- compat/clock_gettime.h now provides a compatibility implementation of
+  clock_gettime(), which fixes building on Mac OS X.
+- Countless man page fixes.
+- praudit XML support via "praudit -x".
+- audit.log.5 expanded to include additional BSM token types.
+
 OpenBSM 1.0 alpha 12
 
 - Correct bug in auditreduce which prevented the -c option from working
--- README	2006/08/23 06:16:19
+++ README	2006/11/05 23:30:33
@@ -76,6 +76,8 @@
     Martin Fong
     Pawel Worach
     Martin Englund
+    Ruslan Ermilov
+    Martin Voros
 
 In addition, Coverity, Inc.'s Prevent(tm) static analysis tool and Gimpel
 Software's FlexeLint tool were used to identify a number of bugs in the
--- TODO	2006/09/24 15:35:32
+++ TODO	2006/11/05 23:30:33
@@ -1,4 +1,3 @@
-- Teach praudit how to general XML format BSM streams.
 - Teach libbsm about any additional 64-bit token types that are present
   in more recent Solaris versions.
 - Build a regression test suite for libbsm that generates each token
--- VERSION	2006/09/21 22:37:23
+++ VERSION	2006/09/24 23:26:29
@@ -1,1 +1,1 @@
-OPENBSM_1_0_ALPHA_12
+OPENBSM_1_0_ALPHA_13
--- bin/auditd/auditd.c	2006/09/22 13:15:35
+++ bin/auditd/auditd.c	2006/10/02 20:03:55
@@ -896,7 +896,7 @@
 	int debug = 0;
 	int rc;
 
-	while ((ch = getopt(argc, argv, "dhs")) != -1) {
+	while ((ch = getopt(argc, argv, "d")) != -1) {
 		switch(ch) {
 		case 'd':
 			/* Debug option. */
--- bin/auditfilterd/auditfilterd.c	2006/08/23 07:49:54
+++ bin/auditfilterd/auditfilterd.c	2006/10/03 12:16:37
@@ -48,6 +48,10 @@
 #include <compat/queue.h>
 #endif
 
+#ifndef HAVE_CLOCK_GETTIME
+#include <compat/clock_gettime.h>
+#endif
+
 #include <bsm/libbsm.h>
 #include <bsm/audit_filter.h>
 
@@ -76,7 +80,7 @@
 usage(void)
 {
 
-	fprintf(stderr, "auditfilterd [-c conffile] [-d] [-p pipefile]"
+	fprintf(stderr, "auditfilterd [-d] [-c conffile] [-p pipefile]"
 	    " [-t trailfile]\n");
 	fprintf(stderr, "  -c    Specify configuration file (default: %s)\n",
 	    AUDITFILTERD_CONFFILE);
--- bin/praudit/praudit.c	2006/02/04 17:00:11
+++ bin/praudit/praudit.c	2006/11/05 23:30:33
@@ -1,5 +1,6 @@
 /*
  * Copyright (c) 2004 Apple Computer, Inc.
+ * Copyright (c) 2006 Martin Voros
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -34,7 +35,7 @@
  */
 
 /*
- * praudit [-lrs] [-ddel] [filenames]
+ * praudit [-lpx] [-r | -s] [-d del] [file ...]
  */
 
 #include <bsm/libbsm.h>
@@ -51,12 +52,14 @@
 static int	 raw = 0;
 static int	 shortfrm = 0;
 static int	 partial = 0;
+static int	 xml = 0;
 
 static void
-usage()
+usage(void)
 {
 
-	fprintf(stderr, "Usage: praudit [-lrs] [-ddel] [filenames]\n");
+	fprintf(stderr, "usage: praudit [-lpx] [-r | -s] [-d del] "
+	    "[file ...]\n");
 	exit(1);
 }
 
@@ -88,11 +91,17 @@
 			if (-1 == au_fetch_tok(&tok, buf + bytesread,
 			    reclen - bytesread))
 				break;
-			au_print_tok(stdout, &tok, del, raw, shortfrm);
+			if (xml)
+				au_print_tok_xml(stdout, &tok, del, raw,
+				    shortfrm);
+			else
+				au_print_tok(stdout, &tok, del, raw,
+				    shortfrm);
 			bytesread += tok.len;
-			if (oneline)
-				printf("%s", del);
-			else
+			if (oneline) {
+				if (!xml)
+					printf("%s", del);
+			} else
 				printf("\n");
 		}
 		free(buf);
@@ -109,12 +118,20 @@
 	int i;
 	FILE *fp;
 
-	while ((ch = getopt(argc, argv, "lprsd:")) != -1) {
+	while ((ch = getopt(argc, argv, "d:lprsx")) != -1) {
 		switch(ch) {
+		case 'd':
+			del = optarg;
+			break;
+
 		case 'l':
 			oneline = 1;
 			break;
 
+		case 'p':
+			partial = 1;
+			break;
+
 		case 'r':
 			if (shortfrm)
 				usage();	/* Exclusive from shortfrm. */
@@ -127,12 +144,8 @@
 			shortfrm = 1;
 			break;
 
-		case 'd':
-			del = optarg;
-			break;
-
-		case 'p':
-			partial = 1;
+		case 'x':
+			xml = 1;
 			break;
 
 		case '?':
@@ -141,6 +154,9 @@
 		}
 	}
 
+	if (xml)
+		au_print_xml_header(stdout);
+
 	/* For each of the files passed as arguments dump the contents. */
 	if (optind == argc) {
 		print_tokens(stdin);
@@ -153,5 +169,9 @@
 		if (fp != NULL)
 			fclose(fp);
 	}
+
+	if (xml)
+		au_print_xml_footer(stdout);
+
 	return (1);
 }
--- bsm/audit_kevents.h	2006/09/22 11:13:41
+++ bsm/audit_kevents.h	2006/10/03 21:35:23
@@ -474,6 +474,28 @@
 #define	AUE_READDIR		43118	/* Linux. */
 #define	AUE_IOPL		43119	/* Linux. */
 #define	AUE_VM86		43120	/* Linux. */
+#define	AUE_MAC_GET_PROC	43121	/* FreeBSD. */
+#define	AUE_MAC_SET_PROC	43122	/* FreeBSD. */
+#define	AUE_MAC_GET_FD		43123	/* FreeBSD. */
+#define	AUE_MAC_GET_FILE	43124	/* FreeBSD. */
+#define	AUE_MAC_SET_FD		43125	/* FreeBSD. */
+#define	AUE_MAC_SET_FILE	43126	/* FreeBSD. */
+#define	AUE_MAC_SYSCALL		43127	/* FreeBSD. */
+#define	AUE_MAC_GET_PID		43128	/* FreeBSD. */
+#define	AUE_MAC_GET_LINK	43129	/* FreeBSD. */
+#define	AUE_MAC_SET_LINK	43130	/* FreeBSD. */
+#define	AUE_MAC_EXECVE		43131	/* FreeBSD. */
+#define	AUE_GETPATH_FROMFD	43132	/* FreeBSD. */
+#define	AUE_GETPATH_FROMADDR	43133	/* FreeBSD. */
+#define	AUE_KMQ_OPEN		43134	/* FreeBSD. */
+#define	AUE_KMQ_SETATTR		43135	/* FreeBSD. */
+#define	AUE_KMQ_TIMEDRECEIVE	43136	/* FreeBSD. */
+#define	AUE_KMQ_TIMEDSEND	43137	/* FreeBSD. */
+#define	AUE_KMQ_NOTIFY		43138	/* FreeBSD. */
+#define	AUE_KMQ_UNLINK		43139	/* FreeBSD. */
+#define	AUE_LISTEN		43140	/* FreeBSD/Darwin/Linux. */
+#define	AUE_MLOCKALL		43141	/* FreeBSD. */
+#define	AUE_MUNLOCKALL		43142	/* FreeBSD. */
 
 /*
  * Darwin BSM uses a number of AUE_O_* definitions, which are aliased to the
@@ -571,16 +593,13 @@
 #define	AUE_GETSOCKOPT		AUE_NULL
 #define	AUE_GTSOCKOPT		AUE_GETSOCKOPT	/* XXX: Typo in Darwin. */
 #define	AUE_ISSETUGID		AUE_NULL
-#define	AUE_LISTEN		AUE_NULL
 #define	AUE_LSTATV		AUE_NULL
 #define	AUE_MADVISE		AUE_NULL
 #define	AUE_MINCORE		AUE_NULL
 #define	AUE_MKCOMPLEX		AUE_NULL
-#define	AUE_MLOCKALL		AUE_NULL
 #define	AUE_MODWATCH		AUE_NULL
 #define	AUE_MSGCL		AUE_NULL
 #define	AUE_MSYNC		AUE_NULL
-#define	AUE_MUNLOCKALL		AUE_NULL
 #define	AUE_PREAD		AUE_NULL
 #define	AUE_PWRITE		AUE_NULL
 #define	AUE_PREADV		AUE_NULL
--- bsm/libbsm.h	2006/09/22 11:30:25
+++ bsm/libbsm.h	2006/11/05 23:30:33
@@ -771,6 +771,14 @@
 //XXX The following interface has different prototype from BSM
 void			 au_print_tok(FILE *outfp, tokenstr_t *tok,
 			    char *del, char raw, char sfrm);
+void			 au_print_tok_xml(FILE *outfp, tokenstr_t *tok,
+			    char *del, char raw, char sfrm);
+
+/* 
+ * Functions relating to XML output.
+ */
+void			 au_print_xml_header(FILE *outfp);
+void			 au_print_xml_footer(FILE *outfp);
 __END_DECLS
 
 /*
--- configure.ac	2006/09/21 22:37:23
+++ configure.ac	2006/09/24 23:26:29
@@ -2,7 +2,7 @@
 # Process this file with autoconf to produce a configure script.
 
 AC_PREREQ(2.59)
-AC_INIT([OpenBSM], [1.0a12], [trustedbsd-audit@TrustesdBSD.org],[openbsm])
+AC_INIT([OpenBSM], [1.0a13], [trustedbsd-audit@TrustesdBSD.org],[openbsm])
 AC_REVISION([$P4$])
 AC_CONFIG_SRCDIR([bin/auditreduce/auditreduce.c])
 AC_CONFIG_AUX_DIR(config)
--- etc/audit_event	2006/09/22 11:13:41
+++ etc/audit_event	2006/10/03 21:35:23
@@ -422,6 +422,28 @@
 43118:AUE_READDIR:readdir(3):no
 43119:AUE_IOPL:linux iopl:ad
 43120:AUE_VM86:linux vm86:pc
+43121:AUE_MAC_GET_PROC:mac_get_proc(2):pc
+43122:AUE_MAC_SET_PROC:mac_set_proc(2):pc
+43123:AUE_MAC_GET_FD:mac_get_fd(2):fa
+43124:AUE_MAC_GET_FILE:mac_get_file(2):fa
+43125:AUE_MAC_SET_FD:mac_set_fd(2):fm
+43126:AUE_MAC_SET_FILE:mac_set_file(2):fm
+43127:AUE_MAC_SYSCALL:mac_syscall(2):ad
+43128:AUE_MAC_GET_PID:mac_get_pid(2):pc
+43129:AUE_MAC_GET_LINK:mac_get_link(2):fa
+43130:AUE_MAC_SET_LINK:mac_set_link(2):fm
+43131:AUE_MAC_EXECVE:mac_exeve(2):ex,pc
+43132:AUE_GETPATH_FROMFD:getpath_fromfd(2):fa
+43133:AUE_GETPATH_FROMADDR:getpath_fromaddr(2):fa
+43134:AUE_KMQ_OPEN:mq_open(2):ip
+43135:AUE_KMQ_SETATTR:mq_setattr(2):ip
+43136:AUE_KMQ_TIMEDRECEIVE:mq_timedreceive(2):ip
+43137:AUE_KMQ_TIMEDSEND:mq_timedsend(2):ip
+43138:AUE_KMQ_NOTIFY:mq_notify(2):ip
+43139:AUE_KMQ_UNLINK:mq_unlink(2):ip
+43140:AUE_LISTEN:listen(2):nt
+43141:AUE_MLOCKALL:mlockall(2):pc
+43142:AUE_MUNLOCKALL:munlockall(2):pc
 #
 # User space system events.
 #
